package com.ghy.order.service;

import com.ghy.order.domain.OrderMaster;
import com.ghy.order.request.AppOrderRequest;
import com.huifu.adapay.core.exception.BaseAdaPayException;

import java.util.List;

/**
 * 主订单接口
 *
 * @author clunt
 */
public interface OrderMasterService {

    String createOrderCode();

    OrderMaster createMasterOrder(AppOrderRequest appOrderRequest);

    /**
     * @param orderMaster 主订单属性
     * @return 成功条数
     */
    int insertOrderMaster(OrderMaster orderMaster);

    /**
     * @param orderMaster 主订单属性
     * @return 成功条数
     */
    int updateOrderMaster(OrderMaster orderMaster) throws BaseAdaPayException;

    /**
     * @param orderMaster 主订单入参
     * @return 主订单集合
     */
    List<OrderMaster> selectOrderMasterList(OrderMaster orderMaster);

    /**
     * @param orderMaster 主订单入参
     * @return 满足条件的主单单量
     */
    Long countOrderMasterList(OrderMaster orderMaster);

    /**
     * @param orderMasterId 主订单id
     * @return 主订单
     */
    OrderMaster selectById(Long orderMasterId);

    /**
     * 用 OrderMaster 查询主订单信息
     *
     * @param orderMasterCode 主订单code
     * @return 主订单信息
     */
    OrderMaster selectByCode(String orderMasterCode);

    /**
     * @param ids 主订单ids
     * @return 删除结果
     */
    int deleteOrderMasterByIds(String ids);

    /**
     * 校验主订单编码是否重复
     *
     * @param orderMaster 主订单属性
     * @return 校验结果 1存在 0不存在
     */
    String checkOrderMasterCodeUnique(OrderMaster orderMaster);

    /**
     * 修改主订单状态
     *
     * @param orderMasterId 主订单ID
     * @param status        主订单状态码
     * @return 0失败 1成功
     */
    int updateStatus(Long orderMasterId, int status);

    /**
     * 主订单完成
     * 由定时器触发 而不是由用户触发（用户只能对子订单操作完成）
     * 当所有的子订单完成后 定时器进入此方法
     * 1.修改主订单状态
     * 2.对提成、分销、罚款、手续费等类型的财务单分销和提现
     *
     * @param orderMasterId 主订单ID
     */
    void finish(Long orderMasterId) throws BaseAdaPayException;

    /**
     * 消费者申请取消主订单
     *
     * @param orderMasterId 主订单ID
     */
    void cancel(Long orderMasterId);

    /**
     * 师傅同意取消主订单
     *
     * @param orderMasterId 主订单ID
     * @param agree         0=不同意 1=同意
     */
    void cancelAgree(Long orderMasterId, Integer agree);

    /**
     * 查询指定状态的订单
     */
    List<OrderMaster> selectByStatus(List<Integer> status);

    /**
     * 查询出未完成(orderStatus < 5)的主订单
     *
     * @return 主订单
     */
    List<OrderMaster> selectUnfinished();
}
